"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// meta.ts
var meta_exports = {};
__export(meta_exports, {
  appendOrCreateContact: () => appendOrCreateContact
});
module.exports = __toCommonJS(meta_exports);

// src/contacts-v4-submit-contact-submitted-contact.http.ts
var import_float = require("@wix/sdk-runtime/transformations/float");
var import_timestamp = require("@wix/sdk-runtime/transformations/timestamp");
var import_transform_paths = require("@wix/sdk-runtime/transformations/transform-paths");
var import_rest_modules = require("@wix/sdk-runtime/rest-modules");
function resolveComWixpressContactsAllocatorApiV4ContactSubmitServiceV4Url(opts) {
  const domainToMappings = {
    "www.wixapis.com": [
      {
        srcPath: "/contacts/v4/contact-submit",
        destPath: "/v4/contact-submit"
      }
    ],
    "www._base_domain_": [
      {
        srcPath: "/_api/contacts/v4/contact-submit",
        destPath: "/v4/contact-submit"
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/contacts/v4/contact-submit",
        destPath: "/v4/contact-submit"
      }
    ],
    _: [
      {
        srcPath: "/_api/contacts/v4/contact-submit",
        destPath: "/v4/contact-submit"
      }
    ],
    "*.dev.wix-code.com": [
      {
        srcPath: "/_api/contacts/v4/contact-submit",
        destPath: "/v4/contact-submit"
      }
    ]
  };
  return (0, import_rest_modules.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_crm_submitted-contact";
function submitContact(payload) {
  function __submitContact({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_float.transformSDKFloatToRESTFloat,
        paths: [
          { path: "info.addresses.items.address.geocode.latitude" },
          { path: "info.addresses.items.address.geocode.longitude" }
        ]
      },
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "info.picture.image.urlExpirationDate" },
          { path: "activity.activityDate" },
          { path: "activity.date" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.contacts.v4.submit_contact",
      method: "POST",
      methodFqn: "com.wixpress.contacts.allocator.api.v4.ContactSubmitServiceV4.SubmitContact",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsAllocatorApiV4ContactSubmitServiceV4Url({
        protoPath: "/v4/contact-submit",
        data: serializedData,
        host
      }),
      data: serializedData
    };
    return metadata;
  }
  return __submitContact;
}

// src/contacts-v4-submit-contact-submitted-contact.meta.ts
function appendOrCreateContact() {
  const payload = {};
  const getRequestOptions = submitContact(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/v4/contact-submit",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  appendOrCreateContact
});
//# sourceMappingURL=meta.js.map