import { HttpClient, NonNullablePaths, MaybeContext, BuildRESTFunction } from '@wix/sdk-types';
import { AppendOrCreateContactOptions, SubmitContactResponse, AppendOrCreateContactApplicationErrors } from './index.typings.mjs';
export { ActivityIcon, Address, AddressLocation, AddressStreetOneOf, AddressTag, AssigneesWrapper, ContactActivity, ContactActivityType, ContactAddress, ContactAddressesWrapper, ContactEmail, ContactEmailsWrapper, ContactInfo, ContactName, ContactPhone, ContactPhonesWrapper, ContactPicture, ContactSourceType, ContactToSubmit, EmailTag, ExtendedFieldsWrapper, IdentificationData, IdentificationDataIdOneOf, IdentityType, ImageProvider, LabelsWrapper, LocationsWrapper, MessageEnvelope, PhoneTag, StreetAddress, Subdivision, SubdivisionType, SubmitContact, SubmitContactOptions, SubmitContactRequest, SubmitOperation, SubmitVisitorIdRequest, SubmitVisitorIdResponse, WebhookIdentityType } from './index.typings.mjs';

declare function appendOrCreateContact$1(httpClient: HttpClient): AppendOrCreateContactSignature;
interface AppendOrCreateContactSignature {
    /**
     * Appends an existing contact or creates a contact if it doesn't exist.
     *
     * For internal docs, see
     * [Submit Contacts](crm.contact-submit-service.introduction).
     */
    (options?: AppendOrCreateContactOptions): Promise<NonNullablePaths<SubmitContactResponse, `contactId` | `identityType` | `newContact`> & {
        __applicationErrorsType?: AppendOrCreateContactApplicationErrors;
    }>;
}

declare const appendOrCreateContact: MaybeContext<BuildRESTFunction<typeof appendOrCreateContact$1> & typeof appendOrCreateContact$1>;

export { AppendOrCreateContactOptions, SubmitContactResponse, appendOrCreateContact };
