// src/contacts-v4-submit-contact-submitted-contact.http.ts
import { transformSDKFloatToRESTFloat } from "@wix/sdk-runtime/transformations/float";
import { transformSDKTimestampToRESTTimestamp } from "@wix/sdk-runtime/transformations/timestamp";
import { transformPaths } from "@wix/sdk-runtime/transformations/transform-paths";
import { resolveUrl } from "@wix/sdk-runtime/rest-modules";
function resolveComWixpressContactsAllocatorApiV4ContactSubmitServiceV4Url(opts) {
  const domainToMappings = {
    "www.wixapis.com": [
      {
        srcPath: "/contacts/v4/contact-submit",
        destPath: "/v4/contact-submit"
      }
    ],
    "www._base_domain_": [
      {
        srcPath: "/_api/contacts/v4/contact-submit",
        destPath: "/v4/contact-submit"
      }
    ],
    "manage._base_domain_": [
      {
        srcPath: "/_api/contacts/v4/contact-submit",
        destPath: "/v4/contact-submit"
      }
    ],
    _: [
      {
        srcPath: "/_api/contacts/v4/contact-submit",
        destPath: "/v4/contact-submit"
      }
    ],
    "*.dev.wix-code.com": [
      {
        srcPath: "/_api/contacts/v4/contact-submit",
        destPath: "/v4/contact-submit"
      }
    ]
  };
  return resolveUrl(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_crm_submitted-contact";
function submitContact(payload) {
  function __submitContact({ host }) {
    const serializedData = transformPaths(payload, [
      {
        transformFn: transformSDKFloatToRESTFloat,
        paths: [
          { path: "info.addresses.items.address.geocode.latitude" },
          { path: "info.addresses.items.address.geocode.longitude" }
        ]
      },
      {
        transformFn: transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "info.picture.image.urlExpirationDate" },
          { path: "activity.activityDate" },
          { path: "activity.date" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.contacts.v4.submit_contact",
      method: "POST",
      methodFqn: "com.wixpress.contacts.allocator.api.v4.ContactSubmitServiceV4.SubmitContact",
      packageName: PACKAGE_NAME,
      url: resolveComWixpressContactsAllocatorApiV4ContactSubmitServiceV4Url({
        protoPath: "/v4/contact-submit",
        data: serializedData,
        host
      }),
      data: serializedData
    };
    return metadata;
  }
  return __submitContact;
}

// src/contacts-v4-submit-contact-submitted-contact.meta.ts
function appendOrCreateContact() {
  const payload = {};
  const getRequestOptions = submitContact(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/v4/contact-submit",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
export {
  appendOrCreateContact
};
//# sourceMappingURL=meta.mjs.map